UVALive 6073 Math Magic

                                              6073 Math Magic
Yesterday, my teacher taught us about math: +, -, *, /, GCD, LCM... As you know, LCM (Least
common multiple) of two positive numbers can be solved easily because of

a ∗ b = GCD(a, b) ∗ LCM(a, b)

In class, I raised a new idea: ”how to calculate the LCM of K numbers”. It’s also an easy problem
indeed, which only cost me 1 minute to solve it. I raised my hand and told teacher about my outstanding
algorithm. Teacher just smiled and smiled ...
After class, my teacher gave me a new problem and he wanted me solve it in 1 minute, too. If we
know three parameters N, M, K, and two equations:

1. SUM(A1, A2, . . . , Ai, Ai+1, . . . , AK) = N
          2. LCM(A1, A2, . . . , Ai, Ai+1, . . . , AK) = M

Can you calculate how many kinds of solutions are there for Ai (Ai are all positive numbers). I
began to roll cold sweat but teacher just smiled and smiled.
Can you solve this problem in 1 minute?
Input
  There are multiple test cases.
  Each test case contains three integers N, M, K. (1 ≤ N, M ≤ 1, 000, 1 ≤ K ≤ 100)
Output
  For each test case, output an integer indicating the number of solution modulo 1,000,000,007(1e9 + 7).
  You can get more details in the sample and hint below.
Hint:
  The ?rst test case: the only solution is (2, 2).
  The second test case: the solution are (1, 2) and (2, 1).

Sample Input
4 2 2
3 2 2

Sample Output
1
2

 1 //今天算是长见识了,纠结,看了大神的代码,才知道用dp
 2 //dp[k][n][m]表示由k个数组成的和为n,最小公倍数为m的情况总数
 3
 4 #include <iostream>
 5 #include <cstdio>
 6 #include <cstring>
 7 #include <algorithm>
 8 using namespace std;
 9 const int maxn = 1005;
10 const int mod = 1000000007;
11 int n, m, k;
12 int lcm[maxn][maxn];
13 int dp[2][maxn][maxn];
14 int fact[maxn], cnt;
15
16 int GCD(int a, int b)
17 {
18     return b==0?a:GCD(b, a%b);
19 }
20
21 int LCM(int a, int b)
22 {
23     return a / GCD(a,b) * b;
24 }
25
26 void init()
27 {
28     for(int i = 1; i <=1000; i++)
29         for(int j = 1; j<=i; j++)
30             lcm[j][i] = lcm[i][j] = LCM(i, j);
31 }
32
33 void solve()
34 {
35     cnt = 0;
36     for(int i = 1; i<=m; i++)
37         if(m%i==0) fact[cnt++] = i;
38
39     int now = 0;
40     memset(dp[now], 0, sizeof(dp[now]));
41     for(int i = 0; i<cnt; i++)
42         dp[now][fact[i]][fact[i]] = 1;
43
44     for(int i = 1; i<k; i++)
45     {
46         now ^= 1;
47         for(int p=1; p<=n; p++)
48             for(int q=0; q<cnt; q++)
49             {
50                 dp[now][p][fact[q]] = 0;
51             }
52
53         for(int p=1; p<=n; p++)
54         {
55             for(int q=0; q<cnt; q++)
56             {
57                 if(dp[now^1][p][fact[q]]==0) continue;
58                 for(int j=0; j<cnt; j++)
59                 {
60                     int now_sum = p + fact[j];
61                     if(now_sum>n) continue;
62                     int now_lcm = lcm[fact[q]][fact[j]];
63                     dp[now][now_sum][now_lcm] += dp[now^1][p][fact[q]];//
64                     dp[now][now_sum][now_lcm] %= mod;//
65                 }
66             }
67         }
68     }
69     printf("%d\n",dp[now][n][m]);
70 }
71
72 int main()
73 {
74     init();
75     while(scanf("%d%d%d", &n, &m, &k)>0)
76         solve();
77     return 0;
78 }

UVALive 6073 Math Magic,布布扣,bubuko.com

时间: 2024-10-16 07:35:39

UVALive 6073 Math Magic的相关文章

DP(优化) UVALive 6073 Math Magic

/************************************************ * Author :Running_Time * Created Time :2015/10/28 星期三 20:20:09 * File Name :H.cpp ************************************************/ #include <cstdio> #include <algorithm> #include <iostream&

Math Magic(完全背包)

Math Magic Time Limit:3000MS     Memory Limit:32768KB     64bit IO Format:%lld & %llu Submit Status Description Yesterday, my teacher taught us about math: +, -, *, /, GCD, LCM... As you know, LCM (Least common multiple) of two positive numbers can b

HDU 4427 Math Magic(三维dp)

题目大意:给你三个数n,m,k.表示有k个数,他们的和为n,k个数的最小公倍数是m.让你求出符合这个条件的k个数的序列有多少种. 一看以为是个数论题,还尝试这各种分解m,然后进行组合数求情况.但是组合出来的数没法做减法啊... 结果是道dp题目.i,j,k表示到了第i个数此时和为j,最小公倍数为k.已经有了多少种组合方法了,直接向后推就可以了啊.数组太大开不开啊,滚动一下就可以了啊. Math Magic Time Limit: 4000/2000 MS (Java/Others)    Mem

ZOJ3662:Math Magic(完全背包)

Yesterday, my teacher taught us about math: +, -, *, /, GCD, LCM... As you know, LCM (Least common multiple) of two positive numbers can be solved easily because of a * b = GCD (a, b) * LCM (a, b). In class, I raised a new idea: "how to calculate the

ZOJ3662:Math Magic(全然背包)

Yesterday, my teacher taught us about math: +, -, *, /, GCD, LCM... As you know, LCM (Least common multiple) of two positive numbers can be solved easily because of a * b = GCD (a, b) * LCM (a, b). In class, I raised a new idea: "how to calculate the

[ZOJ 3662] Math Magic (动态规划+状态压缩)

先贴代码,晚上回去说 1 #include <cstdio> 2 #include <algorithm> 3 #include <cstring> 4 #include <cmath> 5 #include <map> 6 #include <iterator> 7 #include <vector> 8 using namespace std; 9 typedef long long LL; 10 11 int n,m

HDU 4427 Math Magic (2012年长春现场赛H题)

1.题目描述:点击打开链接 2.解题思路:本题要求寻找k个正整数,它们的和恰好是N,它们的LCM恰好是M的解的个数.可以设置一个三维的dp来解决.用dp(i,j,k)表示选择i个数,它们的和恰好是j,它们的LCM恰好是k的个数.那么答案就是dp(k,n,m).不过这里介绍一种利用状态压缩思想求解的方法. 通过题意可以发现,N,M的范围都比较小,不超过1000,而1000之内的所有数的不同素因子的种类数目不超过4个,这是因为2*3*5*7<1000,而2*3*5*7*11>1000.考虑到素因子

ZOJ3662Math Magic(分组背包+完全背包)

I - Math Magic Time Limit:3000MS     Memory Limit:32768KB     64bit IO Format:%lld & %llu Submit Status Description Yesterday, my teacher taught us about math: +, -, *, /, GCD, LCM... As you know, LCM (Least common multiple) of two positive numbers c

2012长春赛区题解(部分)

总结起来自己还是太逗比,DP还是太弱,而DP却恰是算法思维能力的体现,现在要开始注重加强这方面的训练,遇到这类题目总是不敢想,令人担忧. Problem B ZOJ 3656 Bit Magic http://acm.zju.edu.cn/onlinejudge/showProblem.do?problemCode=3656 分析: 总共N个数,每个b[i][j]会对a[i]和a[j]的对应二进制位产生一定影响,具体见题目,我们需要做的是判断每个数的每个位是0或1,根据关系建立边,然后直接2sa